



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android中的IPC机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android中的IPC机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 02:14:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>Android IPC简介</h3>
<p>IPC是Inter-Process Communication的缩写，含义就是进程间通信或者跨进程通信，是指两个进程之间进行数据交换的过程。那么什么是进程，什么是线程，进程和线程是两个截然不同的概念。在操作系统中，线程是CPU调度的最小单元，同时线程是一种有限的系统资源。而进程指的一个执行单元，在PC和移动设备上指的是一个程序或者一个应用。一个进程可以包含多个线程，因此进程和线程是包含被包含的关系，最简单情况下，一个进程可以只有一个线程，即主线程，在Android里面也叫UI线程，在UI线程里才能操作界面元素。</p>
<p>那么在Android中，有特色的进程间通信方式就是Binder了，通过Binder可以轻松实现进程间通信。除了Binder，Android还支持Socket，通过Socket也可以实现任意两个终端之间的通信，当然一个设备上的两个进程之间通过Socket通信自然也是可以的。</p>
<p>说到IPC的使用场景就必须提到多进程，只有面对多进程这种场景下，才需要考虑进程间通信。所有运行在不同进程中的四大组件，只要它们之间需要通过内存来共享数据，都会共享失败，这也是多进程所带来的主要影响。正常情况下，四大组件中间不可能不通过一些中间层来共享数据，那么通过简单地指定进程名来开启多进程都会无法正确运行。一般来说，使用多进程会造成如下几方面的问题：</p>
<ul><li>静态成员和单例模式完全失效</li>
<li>线程同步机制完全失效</li>
<li>SharedPreferences的可靠性下降</li>
<li>Application会多次创建</li></ul>
<p>为了解决这个问题，系统提供了很多跨进程通信方法，虽然说不能直接地共享内存，但是通过跨进程通信我们还是可以实现数据交互。实现跨进程通信的方式有很多，比如通过Intent来传递数据，共享文件SharedPreference，基于Binder的Messenger和AIDL以及Socket等。</p>
<h3>IPC基础概念介绍</h3>
<p><strong>Serializable接口</strong></p>
<p>Serializable是Java提供的一个序列化接口，它是一个空接口，为对象标准的序列化和反序列化操作。使用Serializable来实现序列化相当简单，一句话即可。</p>
<pre class="prettyprint linenums"><code>public class User implements Serializable {<br />
  private static final long seriaVersionUID = 519067123721295773L<br />
}<br />
</code></pre>
<p><strong>Parcelable接口</strong></p>
<p>Parcel内部包装了可序列化的数据，可以在Binder中自由传输，在序列化过程中需要实现的功能有序列化、反序列化和内容描述序列化功能有<code>writeToParcel</code>方法来完成，最终是通过Parcel中的一系列<code>write</code>方法来完成的。用法如下：</p>
<pre class="prettyprint linenums"><code>public class MyParcelable implements Parcelable {<br />
    // You can include parcel data types<br />
    private int mData;<br />
    private String mName;

    // We can also include child Parcelable objects. Assume MySubParcel is such a Parcelable:<br />
    private MySubParcelable mInfo;

    // This is where you write the values you want to save to the `Parcel`.<br />
    // The `Parcel` class has methods defined to help you save all of your values.<br />
    // Note that there are only methods defined for simple values, lists, and other Parcelable objects.<br />
    // You may need to make several classes Parcelable to send the data you want.<br />
    @Override<br />
    public void writeToParcel(Parcel out, int flags) {<br />
        out.writeInt(mData);<br />
        out.writeString(mName);<br />
        out.writeParcelable(mInfo, flags);<br />
    }

    // Using the `in` variable, we can retrieve the values that<br />
    // we originally wrote into the `Parcel`.  This constructor is usually<br />
    // private so that only the `CREATOR` field can access.<br />
    private MyParcelable(Parcel in) {<br />
        mData = in.readInt();<br />
        mName = in.readString();<br />
        mInfo = in.readParcelable(MySubParcelable.class.getClassLoader());<br />
    }

    public MyParcelable() {<br />
        // Normal actions performed by class, since this is still a normal object!<br />
    }

    // In the vast majority of cases you can simply return 0 for this.<br />
    // There are cases where you need to use the constant `CONTENTS_FILE_DESCRIPTOR`<br />
    // But this is out of scope of this tutorial<br />
    @Override<br />
    public int describeContents() {<br />
        return 0;<br />
    }

    // After implementing the `Parcelable` interface, we need to create the<br />
    // `Parcelable.Creator&lt;MyParcelable&gt; CREATOR` constant for our class;<br />
    // Notice how it has our class specified as its type.<br />
    public static final Parcelable.Creator&lt;MyParcelable&gt; CREATOR<br />
            = new Parcelable.Creator&lt;MyParcelable&gt;() {

        // This simply calls our new constructor (typically private) and<br />
        // passes along the unmarshalled `Parcel`, and then returns the new object!<br />
        @Override<br />
        public MyParcelable createFromParcel(Parcel in) {<br />
            return new MyParcelable(in);<br />
        }

        // We just need to copy this and change the type to match our class.<br />
        @Override<br />
        public MyParcelable[] newArray(int size) {<br />
            return new MyParcelable[size];<br />
        }<br />
    };<br />
}<br />
</code></pre>
<p><strong>Serializable和Parcelable区别</strong></p>
<p>Serializable是Java中的序列化接口，其使用起来简单但是开销很大，在序列化和反序列化过程中需要大量的I/O操作。而Parcelable是Android中的序列化方式，因此更适合用在Android平台上，它的缺点就是使用起来稍微麻烦点，但是它的效率很高。</p>
<p><strong>Binder</strong><br /><br />
直观来说，Binder是Android中的一个类，它实现了IBinder接口。从IPC角度来说，Binder是Android中的一种跨进程通信方式，Binder还可以理解为一种虚拟的物理设备，它的设备驱动是/dev/binder，该通信方式在Linux中没有。从Android Framework角度来说，Binder是ServiceManager连接各种Manager(ActivityManager、WindowManager等等)和相应ManagerService的桥梁。从Android应用层来说，Binder是客户端和服务端进行通信的媒介，当bindService的时候，服务端会返回一个包含了服务端业务调用的Binder对象，通过Binder对象，客户端就可以获取服务端提供的服务或者数据，这里的服务包括普通服务和基于AIDL的服务。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/331079/201701/331079-20170122173354191-1274772145.jpg"></p>
<h3>Android中的IPC方式</h3>
<p><strong>使用Bundler</strong></p>
<p>我们知道，四大组件中三大组件（activity、service、receiver）都是支持在Intent中传递Bundle数据的，由于Bundle实现了Parcelable接口，所以它可以方便地在不同的进程间传输。</p>
<p><strong>使用文件共享</strong></p>
<p>共享文件也是一种不错的进程间通信方式，两个进程间通过读/写同一个文件来交换数据，比如A进程把数据写入文件，B进程通过读取这个文件来获取数据。</p>
<p><strong>使用Messenger</strong></p>
<p>Messenger可以翻译为信使，顾名思义，通过它可以在不同进程中传递Message对象，在Message中放入我们需要传递的数据，就可以轻松地实现数据的进程间传递。Messenger是一种轻量级的IPC方案，它的底层实现是AIDL，实现Messenger有以下两个步骤，分为服务端进程和客户端进程。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/331079/201701/331079-20170122173414410-1107539422.jpg"></p>
<p><strong>使用AIDL</strong></p>
<p>远程服务跨进程通信的一种方式。</p>
<p><strong>使用ContentProvider</strong></p>
<p>ContentProvider是Android中提供的专门用于不同应用间进行数据共享的方式，它的底层实现同样也是Binder。</p>
<p><strong>使用Socket</strong></p>
<p>Socket也称为“套接字”，是网络通信中的概念，它分为流式套接字和用户数据套接字两种，分别应于网络的传输控制层中的TCP和UDP协议。</p>
<p><strong>选用合适的IPC方式</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/331079/201701/331079-20170122173430285-1744831757.jpg"></p>
<h3>阅读扩展</h3>
<p>源于对掌握的Android开发基础点进行整理，罗列下已经总结的文章，从中可以看到技术积累的过程。<br /><br />
1，<a href="http://www.cnblogs.com/cr330326/p/4229026.html" rel="external nofollow noreferrer">Android系统简介</a><br /><br />
2，<a href="http://www.cnblogs.com/cr330326/p/5534915.html" rel="external nofollow noreferrer">ProGuard代码混淆</a><br /><br />
3，<a href="http://www.cnblogs.com/cr330326/p/5530222.html" rel="external nofollow noreferrer">讲讲Handler+Looper+MessageQueue关系</a><br /><br />
4，<a href="http://www.cnblogs.com/cr330326/p/5585021.html" rel="external nofollow noreferrer">Android图片加载库理解</a><br /><br />
5，<a href="http://www.cnblogs.com/cr330326/p/5181283.html" rel="external nofollow noreferrer">谈谈Android运行时权限理解</a><br /><br />
6，<a href="http://www.cnblogs.com/cr330326/p/5176038.html" rel="external nofollow noreferrer">EventBus初理解</a><br /><br />
7，<a href="http://www.cnblogs.com/cr330326/p/5176038.html" rel="external nofollow noreferrer">Android 常见工具类</a><br /><br />
8，<a href="http://www.cnblogs.com/cr330326/p/5712022.html" rel="external nofollow noreferrer">对于Fragment的一些理解</a><br /><br />
9，<a href="http://www.cnblogs.com/cr330326/p/5712022.html" rel="external nofollow noreferrer">Android 四大组件之 &quot; Activity &quot;</a><br /><br />
10，<a href="http://www.cnblogs.com/cr330326/p/5741464.html" rel="external nofollow noreferrer">Android 四大组件之&quot; Service &quot;</a><br /><br />
11，<a href="http://www.cnblogs.com/cr330326/p/5787971.html" rel="external nofollow noreferrer">Android 四大组件之“ BroadcastReceiver &quot;</a><br /><br />
12，<a href="http://www.cnblogs.com/cr330326/p/5889279.html" rel="external nofollow noreferrer">Android 四大组件之&quot; ContentProvider &quot;</a><br /><br />
13，<a href="http://www.cnblogs.com/cr330326/p/5997433.html" rel="external nofollow noreferrer">讲讲 Android 事件拦截机制</a><br /><br />
14，<a href="http://www.cnblogs.com/cr330326/p/6062032.html" rel="external nofollow noreferrer">Android 动画的理解</a><br /><br />
15，<a href="http://www.cnblogs.com/cr330326/p/6269820.html" rel="external nofollow noreferrer">Android 生命周期和启动模式</a><br /><br />
16，<a href="http://www.cnblogs.com/cr330326/p/6340958.html" rel="external nofollow noreferrer">Android IPC 机制</a><br /><br />
17，<a href="http://www.cnblogs.com/cr330326/p/6340970.html" rel="external nofollow noreferrer">View 的事件体系</a><br /><br />
18，<a href="http://www.cnblogs.com/cr330326/p/6340973.html" rel="external nofollow noreferrer">View 的工作原理</a><br /><br />
19，<a href="http://www.cnblogs.com/cr330326/p/6364328.html" rel="external nofollow noreferrer">理解 Window 和 WindowManager</a><br /><br />
20，<a href="http://www.cnblogs.com/cr330326/p/6382479.html" rel="external nofollow noreferrer">Activity 启动过程分析</a><br /><br />
21，<a href="http://www.cnblogs.com/cr330326/p/6394071.html" rel="external nofollow noreferrer">Service 启动过程分析</a><br /><br />
22，<a href="http://www.cnblogs.com/cr330326/p/6394094.html" rel="external nofollow noreferrer">Android 性能优化</a><br /><br />
23，<a href="http://www.cnblogs.com/cr330326/p/6408617.html" rel="external nofollow noreferrer">Android 消息机制</a><br /><br />
24，<a href="http://www.cnblogs.com/cr330326/p/6408617.html" rel="external nofollow noreferrer">Android Bitmap相关</a><br /><br />
25，<a href="http://www.cnblogs.com/cr330326/p/6489716.html" rel="external nofollow noreferrer">Android 线程和线程池</a><br /><br />
26，<a href="http://www.cnblogs.com/cr330326/p/6613872.html" rel="external nofollow noreferrer">Android 中的 Drawable 和动画</a><br /><br />
27，<a href="http://www.cnblogs.com/cr330326/p/6647133.html" rel="external nofollow noreferrer">RecylerView 中的装饰者模式</a><br /><br />
28，<a href="http://www.cnblogs.com/cr330326/p/6762542.html" rel="external nofollow noreferrer">Android 触摸事件机制</a><br /><br />
29，<a href="http://www.cnblogs.com/cr330326/p/6796034.html" rel="external nofollow noreferrer">Android 事件机制应用</a><br /><br />
30，<a href="http://www.cnblogs.com/cr330326/p/7082821.html" rel="external nofollow noreferrer">Cordova 框架的一些理解</a><br /><br />
31，<a href="http://www.cnblogs.com/cr330326/p/7222489.html" rel="external nofollow noreferrer">有关 Android 插件化思考</a><br /><br />
32，<a href="http://www.cnblogs.com/cr330326/p/7388143.html" rel="external nofollow noreferrer">开发人员必备技能——单元测试</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2k1o3q.html">ThinkPHP跨控制器调用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvd22zq.html">thinkphp3&period;2与phpexcel带图片生成 完美案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jw3z8.html">Q&colon; ossfs挂载时如何设置权限？</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zpjl19.html">WPF 创建自定义窗体</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw2vv3q.html">&lbrack;Java拾遗四&rsqb;JavaWeb基础之Servlet&lowbar;Request&amp;amp&semi;&amp;amp&semi;Response</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1kjnx9.html">python 写的http后台弱口令爆破工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memlgpq.html">Java疯狂讲义（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjjymk8.html">Unbound classpath container&colon; &amp;amp&semi;&num;39&semi;JRE System Library &lbrack;jdk17060&rsqb;&amp;amp&semi;&num;39&semi; in project &ast;&ast;&ast;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ppkkn8.html">SIGPIPE并产生一个信号处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zo4dk9.html">HDU 2073 无限的路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjnx7j8.html">AUC计算方法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/950n7n68.html">HTML5 进阶系列：拖放 API 实现拖放排序&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9504z308.html">Redux，基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvm4128.html">C&num; 一些不注意知识点：命名空间，等级，class等等</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyzz0q.html">花了2小时写bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25k5v3q.html">华为P20无线投屏到电脑 绝地求生投射电脑</a>
		</li>
						<li><a href="https://www.batexi.com/a/960me539.html">SpringBoot 从application&period;yml中通过&commat;Value读取不到属性值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvp1nl8.html">Mysql字符串字段中是否包含某个字符串，用 find&lowbar;in&lowbar;set</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lwo3q.html">ORA-01919&colon; role &amp;&num;39&semi;PLUSTRACE&amp;&num;39&semi; does not exist</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1ekmeq.html">java接口和抽象类的区别和作用（功能、用途、好处）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jmjjw8.html">php 系列</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jznzve8.html">egret dragonbones部件替换产生位移的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ydy5w8.html">ruby&comma; gem install 出现网络错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxko2508.html">Linux命令 理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8melde0q.html">CentOS 7 源码编译安装 Mysql 5&period;7</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgy4nm8.html">Nginx 负载均衡 后端服务器获取前端用户真实IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zm4239.html">Apache2 三种MPM对比分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj50gy8.html">FZU&Tab;2099 魔法阵</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy145v2q.html">tp框架 使用ajax</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mjpj48.html">iOS开发&mdash;&mdash;UITableView&lpar;未完，待续&period;&period;&period;&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
